/**********************************************************************\
 © COPYRIGHT 2015 Corporation for National Research Initiatives (CNRI);
                        All rights reserved.

        The HANDLE.NET software is made available subject to the
      Handle.Net Public License Agreement, which may be obtained at
          http://hdl.handle.net/20.1000/103 or hdl:20.1000/103
\**********************************************************************/

package net.handle.hdllib.trust;

import java.util.List;

public class ChainVerificationReport {
    public ValuesSignatureVerificationReport valuesReport;
    public List<IssuedSignatureVerificationReport> issuedSignatureVerificationReports;
    public boolean rootIsTrusted;
    
    public boolean canTrustAndGranted() {
        if (!rootIsTrusted) return false;
        if (!valuesReport.correctHandle) return false;
        if (!valuesReport.canTrust()) return false;
        for (IssuedSignatureVerificationReport issuedSignatureVerificationReport : issuedSignatureVerificationReports) {
            if (!issuedSignatureVerificationReport.canTrustAndGranted()) return false;
        }
        return true;
    }
    
    public boolean canTrust() {
        if (!rootIsTrusted) return false;
        for (IssuedSignatureVerificationReport issuedSignatureVerificationReport : issuedSignatureVerificationReports) {
            if (!issuedSignatureVerificationReport.canTrust()) return false;
        }
        return true;
    }
}
